1. 程式人生 > >1. 兩數之和【Leetcode中國,by java】

1. 兩數之和【Leetcode中國,by java】

OS 空間 不知道 argument 轉移 for 一個 cep target

給定一個整數數組和一個目標值,找出數組中和為目標值的兩個數。

你可以假設每個輸入只對應一種答案,且同樣的元素不能被重復利用。

示例:

給定 nums = [2, 7, 11, 15], target = 9

因為 nums[0] + nums[1] = 2 + 7 = 9
所以返回 [0, 1]

解題:今天發現LeetCode原版網站登不上了,不知道是不是被墻了,只好再轉移陣地。這個題目還是比較簡單的,方法也比較多,先看第一種,暴力解法,雙重循環判斷兩個值的和是否與target相等。代碼如下:

 1 class Solution {
 2     public int[] twoSum(int
[] nums, int target) { 3 int[] result = new int[2]; 4 // Arrays.sort(nums); 5 for(int i = 0; i < nums.length-1; i++){ 6 for(int j = i + 1; j < nums.length; j++ ){ 7 if(nums[i] + nums[j] == target){ 8 result[0] = i; 9 result[1] = j;
10 return result; 11 } 12 } 13 } 14 return null; 15 } 16 }

也可以用hash表來做,空間換時間。將每個元素與其對應位置放進HashMap,放之前先判斷表內是否已經有存在對應的數能,與之和能為target,有則返回結果,沒有則繼續放。代碼如下:

 1 class Solution {
 2     public int[] twoSum(int[] nums, int target) {
 3         Map<Integer, Integer>map = new
HashMap<Integer,Integer>(); 4 for(int i =0; i < nums.length; i++){ 5 if( map.containsKey(target - nums[i]) ) 6 return new int[]{map.get(target - nums[i]), i}; 7 map.put(nums[i], i); 8 } 9 throw new IllegalArgumentException(); 10 } 11 }

1. 兩數之和【Leetcode中國,by java】